/*
 * COPYRIGHT:
 * 
 * TITLE TO THE CODE REMAIN WITH ZEB/INFORMATION.TECHNOLOGY. THE CODE IS COPYRIGHTED AND PROTECTED BY LAW. YOU WILL NOT
 * REMOVE ANY COPYRIGHT NOTICE FROM THE CODE. REASSEMBLING, RECOMPILATION, TRANSFER, DISTRIBUTION OR MODIFICATION OF
 * PART OR ALL OF THE CODE IN ANY FORM WITHOUT THE PRIOR WRITTEN PERMISSION OF ZEB/INFORMATION.TECHNOLOGY IS PROHIBITED.
 * 
 * created: 22.02.2012 - 09:20:23
 */
package de.zeb.edu.ejb3.client;


import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.zeb.edu.ejb3.api.BrainBeanRemote;


/**
 * @author swoeste
 * 
 */
public class BrainClient {

    private final static String JNDI_LOCAL  = "java:global/ejb3.ear-0.0.1-SNAPSHOT/ejb3.server-0.0.1-SNAPSHOT/BrainBean";
    private final static String JNDI_REMOTE = "java:global/ejb3.ear-0.0.1-SNAPSHOT/ejb3.server-0.0.1-SNAPSHOT/BrainBean!de.zeb.edu.ejb3.api.BrainBeanRemote";

    private BrainBeanRemote     bean;

    /**
     * Constructor for ...
     */
    public BrainClient() {
        System.out.println( "BrainClient started! (Constructor)" );

        try {
            lockupbean();
        } catch ( NamingException ex ) {
            System.out.println( "Unable to lockup bean!" );
            ex.printStackTrace();
        }
    }

    public String getThought() throws NamingException {
        return this.bean.getThought();
    }

    public void setThought( final String value ) throws NamingException {
        this.bean.setThought( value );
    }

    private BrainBeanRemote lockupbean() throws NamingException {
        if ( this.bean == null ) {
            final Context context = new InitialContext();
            final BrainBeanRemote local = (BrainBeanRemote) context.lookup( JNDI_LOCAL );
            final BrainBeanRemote remote = (BrainBeanRemote) context.lookup( JNDI_REMOTE );

            if ( remote != null ) {
                System.out.println( "Found a remote BrainBean!" );
                this.bean = local;
            }

            if ( local != null ) {
                System.out.println( "Found a local BrainBean!" );
                this.bean = local;
            }

            if ( remote != null ) {
                System.out.println( "Will try to produce the error now ..." );
                remote.produceError( double.class );
            }
        }
        return this.bean;
    }
}
